Index: /branches/proxy/src/lib/gui/gl/Makefile.am
===================================================================
--- /branches/proxy/src/lib/gui/gl/Makefile.am	(revision 9545)
+++ /branches/proxy/src/lib/gui/gl/Makefile.am	(revision 9546)
@@ -22,4 +22,5 @@
 		glgui_bar.cc \
 		glgui_box.cc \
+		glgui_fixedposition_box.cc \
 		glgui_frame.cc \
 		glgui_text.cc \
@@ -49,4 +50,5 @@
 		glgui_bar.h \
 		glgui_box.h \
+		glgui_fixedposition_box.h \
 		glgui_frame.h \
 		glgui_text.h \
Index: /branches/proxy/src/lib/gui/gl/glgui_box.h
===================================================================
--- /branches/proxy/src/lib/gui/gl/glgui_box.h	(revision 9545)
+++ /branches/proxy/src/lib/gui/gl/glgui_box.h	(revision 9546)
@@ -1,4 +1,4 @@
 /*!
- * @file glgui_.h
+ * @file glgui_box.h
  * The gl_box widget of th openglGUI
  *
Index: /branches/proxy/src/lib/gui/gl/glgui_defs.h
===================================================================
--- /branches/proxy/src/lib/gui/gl/glgui_defs.h	(revision 9545)
+++ /branches/proxy/src/lib/gui/gl/glgui_defs.h	(revision 9546)
@@ -23,8 +23,37 @@
 
   //! Names of Orientations
-  const std::string OrientationString[] = {
-    "Horizontal",
-    "Vertical"
-  };
+  const std::string OrientationString[] =
+    {
+      "Horizontal",
+      "Vertical"
+    };
+
+  //! An enumeration for the Positions of some Elements (FixedPositionBox as an example).
+  typedef enum {
+    Left,               //!< Left
+    Right,              //!< Right
+    Top,                //!< Top
+    Bottom,             //!< Bottom
+    TopLeft,            //!< TopLeft
+    TopRight,           //!< TopRight
+    BottomLeft,         //!< BottomLeft
+    BottomRight,        //!< BottomRight
+    Center,             //!< Centered
+  } Position;
+
+  //! Names of Positions
+  const std::string PositionString[] =
+    {
+      "Left",
+      "Right",
+      "Top",
+      "Bottom",
+      "TopLeft",
+      "TopRight",
+      "BottomLeft",
+      "BottomRight",
+      "Center"
+    };
+
 
   //! An enumerator that defines the different states Widgets may be in.
@@ -39,5 +68,5 @@
 #define GLGUI_DEFAULT_STYLE OrxGui::Normal
 
-//! names of the States.
+  //! names of the States.
   const std::string StateString[] =
     {
@@ -48,14 +77,14 @@
     };
 
-    //! Where a Certain feature will be positioned at.
-    typedef enum {
-      FeatureLeft,          //!< On the Left side.
-      FeatureRight,         //!< On the Right side.
-      FeatureTop,           //!< On Top of the rest of the Widget.
-      FeatureBottom,        //!< At the Bottom of the rest of the Widget.
-    } FeaturePosition;
+  //! Where a Certain feature will be positioned at.
+  typedef enum {
+    FeatureLeft,          //!< On the Left side.
+    FeatureRight,         //!< On the Right side.
+    FeatureTop,           //!< On Top of the rest of the Widget.
+    FeatureBottom,        //!< At the Bottom of the rest of the Widget.
+  } FeaturePosition;
 
-    //! Names of Feature-Positions
-    const std::string FeaturePositionString[] =
+  //! Names of Feature-Positions
+  const std::string FeaturePositionString[] =
     {
       "Left",
Index: /branches/proxy/src/lib/gui/gl/glgui_fixedposition_box.cc
===================================================================
--- /branches/proxy/src/lib/gui/gl/glgui_fixedposition_box.cc	(revision 9546)
+++ /branches/proxy/src/lib/gui/gl/glgui_fixedposition_box.cc	(revision 9546)
@@ -0,0 +1,63 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_GUI
+
+#include "glgui_fixedposition_box.h"
+#include "glgui_handler.h"
+#include <cassert>
+
+namespace OrxGui
+{
+  /**
+   * standard constructor
+  */
+  GLGuiFixedpositionBox::GLGuiFixedpositionBox (OrxGui::Position position, OrxGui::Orientation orientation)
+      GLGuiBox(orientation)
+  {
+  }
+
+
+  /**
+   * standard deconstructor
+  */
+  GLGuiFixedpositionBox::~GLGuiFixedpositionBox()
+  {}
+
+
+  void GLGuiFixedpositionBox::setPosition(OrxGui::Position position)
+  {
+    this->_position = position;
+    this->resize;
+  }
+
+
+  void GLGuiFixedpositionBox::resize()
+  {
+    GLGuiBox::resize();
+
+    switch (this->position)
+    {
+      case OrxGui::Center:
+        this->setAbsCoor2D(GuiHandler::getInstance()->resolution() - this->getSize2D() / 2.0);
+        break;
+
+    }
+    // resize everything.
+    //for (widget = this->children.begin(); widget != this->children.end(); ++widget)
+    //{}
+  }
+
+}
Index: /branches/proxy/src/lib/gui/gl/glgui_fixedposition_box.h
===================================================================
--- /branches/proxy/src/lib/gui/gl/glgui_fixedposition_box.h	(revision 9546)
+++ /branches/proxy/src/lib/gui/gl/glgui_fixedposition_box.h	(revision 9546)
@@ -0,0 +1,37 @@
+/*!
+ * @file glgui_fixedposition_box.h
+ * The gl_fixedposition_box widget of th openglGUi
+ */
+
+#ifndef _GLGUI_FIXEDPOSITION_BOX_H
+#define _GLGUI_FIXEDPOSITION_BOX_H
+
+#include "glgui_container.h"
+#include "glgui_defs.h"
+
+namespace OrxGui
+{
+  //! This is BOX part of the openglGUI class
+  /**
+   *
+   */
+  class GLGuiFixedpositionBox : public GLGuiBox
+  {
+
+  public:
+    GLGuiFixedpositionBox(OrxGui::Position position = OrxGui::Center, OrxGui::Orientation orientation = OrxGui::Vertical);
+    virtual ~GLGuiFixedpositionBox();
+
+    inline OrxGui::Position position() const { return _position; };
+    void setPosition(OrxGui::Position);
+
+
+  protected:
+    virtual void resize();
+
+
+  private:
+    OrxGui::Position     _position;     //!< The Fixed position of the Widget.
+  };
+}
+#endif /* _GLGUI_FIXEDPOSITION_BOX_H */
Index: /branches/proxy/src/lib/gui/gl/glgui_handler.cc
===================================================================
--- /branches/proxy/src/lib/gui/gl/glgui_handler.cc	(revision 9545)
+++ /branches/proxy/src/lib/gui/gl/glgui_handler.cc	(revision 9546)
@@ -28,6 +28,4 @@
 #include "debug.h"
 
-#include <cassert>
-
 
 /// TAKE THIS OUT OF HERE.
@@ -93,4 +91,5 @@
   void GLGuiHandler::activate()
   {
+    this->_resolution = Vector2D(GraphicsEngine::getInstance()->getResolutionX(), GraphicsEngine::getInstance()->getResolutionY());
     //EventHandler::getInstance()->pushState(ES_MENU);
 
@@ -244,5 +243,7 @@
         if (this->_cursor != NULL)
           this->_cursor->setMaxBorders(Vector2D(event.resize.w, event.resize.h));
-        break;
+        this->_resolution = Vector2D(event.resize.w, event.resize.h);
+        break;
+
       case SDLK_TAB:
         if (event.bPressed)
Index: /branches/proxy/src/lib/gui/gl/glgui_handler.h
===================================================================
--- /branches/proxy/src/lib/gui/gl/glgui_handler.h	(revision 9545)
+++ /branches/proxy/src/lib/gui/gl/glgui_handler.h	(revision 9546)
@@ -12,8 +12,7 @@
 namespace OrxGui
 {
-
+ // FORWARD DECLARATION
   class GLGuiCursor;
 
-  // FORWARD DECLARATION
 
   //! A singleton class for the GLGui-Handler
@@ -22,7 +21,8 @@
 
   public:
-    virtual ~GLGuiHandler(void);
     /** @returns a Pointer to the only object of this Class */
     inline static GLGuiHandler* getInstance(void) { if (!GLGuiHandler::singletonRef) GLGuiHandler::singletonRef = new GLGuiHandler();  return GLGuiHandler::singletonRef; };
+    /** @brief deletes the instance if it exists */
+    inline static void deleteInstance() { if (GLGuiHandler::singletonRef) delete GLGuiHandler::singletonRef; };
 
     void activateCursor();
@@ -33,4 +33,6 @@
     const Vector2D& cursorPositionAbs() const;
     Vector2D cursorPositionRel(const GLGuiWidget* const widget) const;
+
+    const Vector2D& resolution() const { return this->_resolution; };
 
     void selectNext();
@@ -48,4 +50,5 @@
   private:
     GLGuiHandler(void);
+    virtual ~GLGuiHandler(void);
     static GLGuiHandler* singletonRef;
 
@@ -53,4 +56,5 @@
     bool                 isActive;
     GLGuiCursor*         _cursor;
+    Vector2D             _resolution;
 
   };
Index: /branches/proxy/src/lib/network/monitor/network_stats_widget.cc
===================================================================
--- /branches/proxy/src/lib/network/monitor/network_stats_widget.cc	(revision 9545)
+++ /branches/proxy/src/lib/network/monitor/network_stats_widget.cc	(revision 9546)
@@ -169,5 +169,9 @@
   this->_bar.setChangedValueColor(Color::black);
   */
-  this->pack(&this->_thisHost);
+  this->_thisHostIs.setText(std::string("I am ") + _monitor->getLocalNode()->getPeerInfo()->getNodeTypeString());
+
+  this->pack(&this->_thisHostIs);
+
+this->pack(&this->_thisHost);
 
   this->pack(&this->_upstreamText);
Index: /branches/proxy/src/lib/network/monitor/network_stats_widget.h
===================================================================
--- /branches/proxy/src/lib/network/monitor/network_stats_widget.h	(revision 9545)
+++ /branches/proxy/src/lib/network/monitor/network_stats_widget.h	(revision 9546)
@@ -2,5 +2,5 @@
  * @file network_stats_widget.h
  * @brief Definition of an EnergyWidget, that displays a bar and a Text
-*/
+ */
 
 #ifndef _NETWORK_STATS_WIDGET_H
@@ -101,4 +101,5 @@
     const NetworkMonitor*  _monitor;
 
+    OrxGui::GLGuiText      _thisHostIs;
     HostWidget             _thisHost;
 
Index: /branches/proxy/src/story_entities/menu/game_menu.cc
===================================================================
--- /branches/proxy/src/story_entities/menu/game_menu.cc	(revision 9545)
+++ /branches/proxy/src/story_entities/menu/game_menu.cc	(revision 9546)
@@ -76,5 +76,5 @@
   if( this->dataTank)
     delete this->dataTank;
-  delete OrxGui::GLGuiHandler::getInstance( );
+  OrxGui::GLGuiHandler::deleteInstance( );
 }
 
Index: /branches/proxy/src/story_entities/multi_player_world.cc
===================================================================
--- /branches/proxy/src/story_entities/multi_player_world.cc	(revision 9545)
+++ /branches/proxy/src/story_entities/multi_player_world.cc	(revision 9546)
@@ -63,5 +63,5 @@
   if( this->dataTank)
     delete this->dataTank;
-  delete OrxGui::GLGuiHandler::getInstance( );
+  OrxGui::GLGuiHandler::deleteInstance( );
 }
 