Index: code/branches/testing/src/libraries/core/Core.cc
===================================================================
--- code/branches/testing/src/libraries/core/Core.cc	(revision 9546)
+++ code/branches/testing/src/libraries/core/Core.cc	(revision 9547)
@@ -181,5 +181,5 @@
 
         // Set the correct log path and rewrite the log file with the correct log levels
-        OutputManager::getInstance().getLogWriter().setLogDirectory(PathConfig::getLogPathString());
+        OutputManager::getInstance().getLogWriter()->setLogDirectory(PathConfig::getLogPathString());
 
 #if !defined(ORXONOX_PLATFORM_APPLE) && !defined(ORXONOX_USE_WINMAIN)
@@ -259,22 +259,22 @@
     void Core::setConfigValues()
     {
-        SetConfigValueExternal(OutputManager::getInstance().getLogWriter().configurableMaxLevel_,
-                               OutputManager::getInstance().getLogWriter().getConfigurableSectionName(),
-                               OutputManager::getInstance().getLogWriter().getConfigurableMaxLevelName(),
-                               OutputManager::getInstance().getLogWriter().configurableMaxLevel_)
+        SetConfigValueExternal(OutputManager::getInstance().getLogWriter()->configurableMaxLevel_,
+                               OutputManager::getInstance().getLogWriter()->getConfigurableSectionName(),
+                               OutputManager::getInstance().getLogWriter()->getConfigurableMaxLevelName(),
+                               OutputManager::getInstance().getLogWriter()->configurableMaxLevel_)
             .description("The maximum level of output shown in the log file")
-            .callback(static_cast<BaseWriter*>(&OutputManager::getInstance().getLogWriter()), &BaseWriter::changedConfigurableLevel);
-        SetConfigValueExternal(OutputManager::getInstance().getLogWriter().configurableAdditionalContextsMaxLevel_,
-                               OutputManager::getInstance().getLogWriter().getConfigurableSectionName(),
-                               OutputManager::getInstance().getLogWriter().getConfigurableAdditionalContextsMaxLevelName(),
-                               OutputManager::getInstance().getLogWriter().configurableAdditionalContextsMaxLevel_)
+            .callback(static_cast<BaseWriter*>(OutputManager::getInstance().getLogWriter()), &BaseWriter::changedConfigurableLevel);
+        SetConfigValueExternal(OutputManager::getInstance().getLogWriter()->configurableAdditionalContextsMaxLevel_,
+                               OutputManager::getInstance().getLogWriter()->getConfigurableSectionName(),
+                               OutputManager::getInstance().getLogWriter()->getConfigurableAdditionalContextsMaxLevelName(),
+                               OutputManager::getInstance().getLogWriter()->configurableAdditionalContextsMaxLevel_)
             .description("The maximum level of output shown in the log file for additional contexts")
-            .callback(static_cast<BaseWriter*>(&OutputManager::getInstance().getLogWriter()), &BaseWriter::changedConfigurableAdditionalContextsLevel);
-        SetConfigValueExternal(OutputManager::getInstance().getLogWriter().configurableAdditionalContexts_,
-                               OutputManager::getInstance().getLogWriter().getConfigurableSectionName(),
-                               OutputManager::getInstance().getLogWriter().getConfigurableAdditionalContextsName(),
-                               OutputManager::getInstance().getLogWriter().configurableAdditionalContexts_)
+            .callback(static_cast<BaseWriter*>(OutputManager::getInstance().getLogWriter()), &BaseWriter::changedConfigurableAdditionalContextsLevel);
+        SetConfigValueExternal(OutputManager::getInstance().getLogWriter()->configurableAdditionalContexts_,
+                               OutputManager::getInstance().getLogWriter()->getConfigurableSectionName(),
+                               OutputManager::getInstance().getLogWriter()->getConfigurableAdditionalContextsName(),
+                               OutputManager::getInstance().getLogWriter()->configurableAdditionalContexts_)
             .description("Additional output contexts shown in the log file")
-            .callback(static_cast<BaseWriter*>(&OutputManager::getInstance().getLogWriter()), &BaseWriter::changedConfigurableAdditionalContexts);
+            .callback(static_cast<BaseWriter*>(OutputManager::getInstance().getLogWriter()), &BaseWriter::changedConfigurableAdditionalContexts);
 
         SetConfigValue(bDevMode_, PathConfig::buildDirectoryRun())
Index: code/branches/testing/src/libraries/core/command/Shell.cc
===================================================================
--- code/branches/testing/src/libraries/core/command/Shell.cc	(revision 9546)
+++ code/branches/testing/src/libraries/core/command/Shell.cc	(revision 9547)
@@ -88,5 +88,5 @@
 
         // Get the previous output and add it to the Shell
-        OutputManager::getInstance().getMemoryWriter().resendOutput(this);
+        OutputManager::getInstance().getMemoryWriter()->resendOutput(this);
     }
 
Index: code/branches/testing/src/libraries/util/output/LogWriter.cc
===================================================================
--- code/branches/testing/src/libraries/util/output/LogWriter.cc	(revision 9546)
+++ code/branches/testing/src/libraries/util/output/LogWriter.cc	(revision 9547)
@@ -168,6 +168,6 @@
 
         // request old output from MemoryWriter
-        if (&OutputManager::getInstance().getMemoryWriter())
-            OutputManager::getInstance().getMemoryWriter().resendOutput(this);
+        if (OutputManager::getInstance().getMemoryWriter())
+            OutputManager::getInstance().getMemoryWriter()->resendOutput(this);
     }
 
Index: code/branches/testing/src/libraries/util/output/OutputManager.h
===================================================================
--- code/branches/testing/src/libraries/util/output/OutputManager.h	(revision 9546)
+++ code/branches/testing/src/libraries/util/output/OutputManager.h	(revision 9547)
@@ -72,7 +72,7 @@
             static OutputManager& getInstanceAndCreateListeners();
 
-            inline MemoryWriter& getMemoryWriter()   { return *this->memoryWriterInstance_; }
-            inline ConsoleWriter& getConsoleWriter() { return *this->consoleWriterInstance_; }
-            inline LogWriter& getLogWriter()         { return *this->logWriterInstance_; }
+            inline MemoryWriter* getMemoryWriter()   { return this->memoryWriterInstance_; }
+            inline ConsoleWriter* getConsoleWriter() { return this->consoleWriterInstance_; }
+            inline LogWriter* getLogWriter()         { return this->logWriterInstance_; }
 
             virtual void pushMessage(OutputLevel level, const OutputContextContainer& context, const std::string& message);
Index: code/branches/testing/src/orxonox/overlays/InGameConsole.cc
===================================================================
--- code/branches/testing/src/orxonox/overlays/InGameConsole.cc	(revision 9546)
+++ code/branches/testing/src/orxonox/overlays/InGameConsole.cc	(revision 9547)
@@ -96,5 +96,5 @@
         // Output buffering is not anymore needed. Not the best solution to do
         // this here, but there isn't much of another way.
-        OutputManager::getInstance().getMemoryWriter().disable();
+        OutputManager::getInstance().getMemoryWriter()->disable();
     }
 
Index: code/branches/testing/test/util/output/ConsoleWriterTest.cc
===================================================================
--- code/branches/testing/test/util/output/ConsoleWriterTest.cc	(revision 9546)
+++ code/branches/testing/test/util/output/ConsoleWriterTest.cc	(revision 9547)
@@ -66,5 +66,5 @@
     {
         OutputManager::getInstanceAndCreateListeners();
-        EXPECT_EQ(std::cout, OutputManager::getInstance().getConsoleWriter().getOutputStream());
+        EXPECT_EQ(std::cout, OutputManager::getInstance().getConsoleWriter()->getOutputStream());
     }
 }
Index: code/branches/testing/test/util/output/OutputManagerTest.cc
===================================================================
--- code/branches/testing/test/util/output/OutputManagerTest.cc	(revision 9546)
+++ code/branches/testing/test/util/output/OutputManagerTest.cc	(revision 9547)
@@ -54,7 +54,7 @@
     TEST(OutputManagerTest, GetInstanceDoesNotCreateDefaultListeners)
     {
-        EXPECT_TRUE(NULL == &OutputManager::getInstance().getMemoryWriter());
-        EXPECT_TRUE(NULL == &OutputManager::getInstance().getConsoleWriter());
-        EXPECT_TRUE(NULL == &OutputManager::getInstance().getLogWriter());
+        EXPECT_TRUE(NULL == OutputManager::getInstance().getMemoryWriter());
+        EXPECT_TRUE(NULL == OutputManager::getInstance().getConsoleWriter());
+        EXPECT_TRUE(NULL == OutputManager::getInstance().getLogWriter());
     }
 
@@ -62,7 +62,7 @@
     TEST(OutputManagerTest, GetInstanceAndCreateListenersCreatesDefaultListeners)
     {
-        EXPECT_TRUE(NULL != &OutputManager::getInstanceAndCreateListeners().getMemoryWriter());
-        EXPECT_TRUE(NULL != &OutputManager::getInstanceAndCreateListeners().getConsoleWriter());
-        EXPECT_TRUE(NULL != &OutputManager::getInstanceAndCreateListeners().getLogWriter());
+        EXPECT_TRUE(NULL != OutputManager::getInstanceAndCreateListeners().getMemoryWriter());
+        EXPECT_TRUE(NULL != OutputManager::getInstanceAndCreateListeners().getConsoleWriter());
+        EXPECT_TRUE(NULL != OutputManager::getInstanceAndCreateListeners().getLogWriter());
     }
 
@@ -70,11 +70,11 @@
     TEST(OutputManagerTest, GetInstanceAndCreateListenersDoesNotCreateDefaultListenersTwice)
     {
-        MemoryWriter* memoryWriter = &OutputManager::getInstanceAndCreateListeners().getMemoryWriter();
-        ConsoleWriter* consoleWriter = &OutputManager::getInstanceAndCreateListeners().getConsoleWriter();
-        LogWriter* logWriter = &OutputManager::getInstanceAndCreateListeners().getLogWriter();
-
-        EXPECT_TRUE(memoryWriter == &OutputManager::getInstanceAndCreateListeners().getMemoryWriter());
-        EXPECT_TRUE(consoleWriter == &OutputManager::getInstanceAndCreateListeners().getConsoleWriter());
-        EXPECT_TRUE(logWriter == &OutputManager::getInstanceAndCreateListeners().getLogWriter());
+        MemoryWriter* memoryWriter = OutputManager::getInstanceAndCreateListeners().getMemoryWriter();
+        ConsoleWriter* consoleWriter = OutputManager::getInstanceAndCreateListeners().getConsoleWriter();
+        LogWriter* logWriter = OutputManager::getInstanceAndCreateListeners().getLogWriter();
+
+        EXPECT_TRUE(memoryWriter == OutputManager::getInstanceAndCreateListeners().getMemoryWriter());
+        EXPECT_TRUE(consoleWriter == OutputManager::getInstanceAndCreateListeners().getConsoleWriter());
+        EXPECT_TRUE(logWriter == OutputManager::getInstanceAndCreateListeners().getLogWriter());
     }
 
Index: code/branches/testing/test/util/output/OutputStreamTest.cc
===================================================================
--- code/branches/testing/test/util/output/OutputStreamTest.cc	(revision 9546)
+++ code/branches/testing/test/util/output/OutputStreamTest.cc	(revision 9547)
@@ -64,5 +64,5 @@
     {
         // disable MemoryWriter because otherwise we would always accept all output
-        OutputManager::getInstance().getMemoryWriter().disable();
+        OutputManager::getInstance().getMemoryWriter()->disable();
 
         {
@@ -140,5 +140,5 @@
     {
         // disable MemoryWriter because otherwise we would always accept all output
-        OutputManager::getInstanceAndCreateListeners().getMemoryWriter().disable();
+        OutputManager::getInstanceAndCreateListeners().getMemoryWriter()->disable();
 
         OutputStream stream;