Index: /branches/proxy/src/lib/BuildLibs.am
===================================================================
--- /branches/proxy/src/lib/BuildLibs.am	(revision 9553)
+++ /branches/proxy/src/lib/BuildLibs.am	(revision 9554)
@@ -3,4 +3,5 @@
                 $(LIB_PREFIX)/util/libORXlibutil.a \
                 $(LIB_PREFIX)/shell/libORXshell.a \
+                $(LIB_PREFIX)/event/libORXevent.a \
                 $(LIB_PREFIX)/gui/qt/libORXqtgui.a \
                 $(LIB_PREFIX)/gui/gl/libORXglgui.a \
@@ -11,5 +12,4 @@
                 $(LIB_PREFIX)/graphics/importer/libtc.a \
                 $(LIB_PREFIX)/sound/libORXsound.a \
-                $(LIB_PREFIX)/event/libORXevent.a \
                 $(LIB_PREFIX)/particles/libORXparticles.a \
                 $(LIB_PREFIX)/collision_detection/libORXcd.a \
Index: /branches/proxy/src/lib/gui/gl/glgui_fixedposition_box.cc
===================================================================
--- /branches/proxy/src/lib/gui/gl/glgui_fixedposition_box.cc	(revision 9553)
+++ /branches/proxy/src/lib/gui/gl/glgui_fixedposition_box.cc	(revision 9554)
@@ -28,5 +28,7 @@
   GLGuiFixedpositionBox::GLGuiFixedpositionBox (OrxGui::Position position, OrxGui::Orientation orientation)
       : GLGuiBox(orientation)
-  {}
+  {
+    this->subscribeEvent(ES_ALL, EV_VIDEO_RESIZE);
+  }
 
 
@@ -45,5 +47,5 @@
     {
       case OrxGui::Center:
-        this->setAbsCoor2D(GLGuiHandler::getInstance()->resolution() - this->getSize2D() / 2.0);
+        this->setAbsCoor2D(GLGuiHandler::getInstance()->resolution()/2.0 - this->getSize2D() / 2.0);
         break;
       default:
@@ -56,3 +58,16 @@
   }
 
+  void GLGuiFixedpositionBox::process(const Event& event)
+  {
+    switch(event.type)
+    {
+      case EV_VIDEO_RESIZE:
+        this->resize();
+        break;
+
+    }
+
+  }
+
+
 }
Index: /branches/proxy/src/lib/gui/gl/glgui_fixedposition_box.h
===================================================================
--- /branches/proxy/src/lib/gui/gl/glgui_fixedposition_box.h	(revision 9553)
+++ /branches/proxy/src/lib/gui/gl/glgui_fixedposition_box.h	(revision 9554)
@@ -8,4 +8,5 @@
 
 #include "glgui_box.h"
+#include "event_listener.h"
 
 namespace OrxGui
@@ -15,5 +16,5 @@
    *
    */
-  class GLGuiFixedpositionBox : public OrxGui::GLGuiBox
+  class GLGuiFixedpositionBox : public OrxGui::GLGuiBox, EventListener
   {
 
@@ -26,4 +27,5 @@
     protected:
       virtual void resize();
+      virtual void process(const Event& event); //!< from eventListener
 
     private:
Index: /branches/proxy/src/lib/gui/gl/glgui_handler.cc
===================================================================
--- /branches/proxy/src/lib/gui/gl/glgui_handler.cc	(revision 9553)
+++ /branches/proxy/src/lib/gui/gl/glgui_handler.cc	(revision 9554)
@@ -44,4 +44,5 @@
     this->setName("GLGuiHandler");
 
+    this->_resolution = Vector2D(GraphicsEngine::getInstance()->getResolutionX(), GraphicsEngine::getInstance()->getResolutionY());
 
     EventHandler::getInstance()->withUNICODE(ES_MENU, true );
@@ -91,5 +92,4 @@
   void GLGuiHandler::activate()
   {
-    this->_resolution = Vector2D(GraphicsEngine::getInstance()->getResolutionX(), GraphicsEngine::getInstance()->getResolutionY());
     //EventHandler::getInstance()->pushState(ES_MENU);
 
Index: /branches/proxy/src/lib/network/monitor/network_monitor.cc
===================================================================
--- /branches/proxy/src/lib/network/monitor/network_monitor.cc	(revision 9553)
+++ /branches/proxy/src/lib/network/monitor/network_monitor.cc	(revision 9554)
@@ -211,5 +211,5 @@
 
     this->box->showAll();
-    this->box->setAbsCoor2D(300, 40);
+    //this->box->setAbsCoor2D(300, 40);
   }
   else
Index: /branches/proxy/src/lib/network/monitor/network_stats_widget.cc
===================================================================
--- /branches/proxy/src/lib/network/monitor/network_stats_widget.cc	(revision 9553)
+++ /branches/proxy/src/lib/network/monitor/network_stats_widget.cc	(revision 9554)
@@ -147,5 +147,5 @@
  */
 NetworkStatsWidget::NetworkStatsWidget(const NetworkMonitor* monitor)
-  : GLGuiFixedpositionBox(OrxGui::Center, OrxGui::Vertical), _thisHost("myName", IP(127, 0, 0 , 1))
+  : OrxGui::GLGuiFixedpositionBox(OrxGui::Center, OrxGui::Vertical), _thisHost("myName", IP(127, 0, 0 , 1))
 {
   this->_monitor = monitor;