Index: /code/branches/core6/src/libraries/core/object/Iterator.h
===================================================================
--- /code/branches/core6/src/libraries/core/object/Iterator.h	(revision 9572)
+++ /code/branches/core6/src/libraries/core/object/Iterator.h	(revision 9573)
@@ -69,5 +69,5 @@
         @see See @ref IteratorExample "Iterator.h" for more information an example.
     */
-    template <class T = OrxonoxClass>
+    template <class T>
     class Iterator
     {
@@ -295,5 +295,5 @@
                 @param object The object to compare with
             */
-            inline void incrementIfEqual(OrxonoxClass* object)
+            inline void incrementIfEqual(Listable* object)
             {
                 if (this->element_ && this->element_->objectBase_ == object)
@@ -305,6 +305,4 @@
             ObjectListBase* list_;                 //!< The list wherein the element is
     };
-
-    typedef Iterator<OrxonoxClass> BaseIterator;
 }
 
Index: /code/branches/core6/src/libraries/core/object/ObjectListBase.cc
===================================================================
--- /code/branches/core6/src/libraries/core/object/ObjectListBase.cc	(revision 9572)
+++ /code/branches/core6/src/libraries/core/object/ObjectListBase.cc	(revision 9573)
@@ -68,10 +68,10 @@
         @param object The object that gets removed
     */
-    void ObjectListBase::notifyIterators(OrxonoxClass* object) const
+    void ObjectListBase::notifyIterators(Listable* object) const
     {
         for (std::vector<void*>::const_iterator it = this->iterators_.begin(); it != this->iterators_.end(); ++it)
-            ((Iterator<OrxonoxClass>*)(*it))->incrementIfEqual(object);
+            ((Iterator<Listable>*)(*it))->incrementIfEqual(object);
         for (std::vector<void*>::const_iterator it = this->objectListIterators_.begin(); it != this->objectListIterators_.end(); ++it)
-            ((ObjectListIterator<OrxonoxClass>*)(*it))->incrementIfEqual(object);
+            ((ObjectListIterator<Listable>*)(*it))->incrementIfEqual(object);
     }
 
Index: /code/branches/core6/src/libraries/core/object/ObjectListBase.h
===================================================================
--- /code/branches/core6/src/libraries/core/object/ObjectListBase.h	(revision 9572)
+++ /code/branches/core6/src/libraries/core/object/ObjectListBase.h	(revision 9573)
@@ -56,9 +56,9 @@
                 @param objectBase The object to store
             */
-            ObjectListBaseElement(OrxonoxClass* objectBase) : next_(0), prev_(0), objectBase_(objectBase) {}
+            ObjectListBaseElement(Listable* objectBase) : next_(0), prev_(0), objectBase_(objectBase) {}
 
             ObjectListBaseElement* next_;       //!< The next element in the list
             ObjectListBaseElement* prev_;       //!< The previous element in the list
-            OrxonoxClass* objectBase_;
+            Listable* objectBase_;
     };
 
@@ -72,5 +72,5 @@
     {
         public:
-            ObjectListElement(T* object) : ObjectListBaseElement(static_cast<OrxonoxClass*>(object)), object_(object) {}
+            ObjectListElement(T* object) : ObjectListBaseElement(static_cast<Listable*>(object)), object_(object) {}
             T* object_;              //!< The object
     };
@@ -142,5 +142,5 @@
                 }
             }
-            void notifyIterators(OrxonoxClass* object) const;
+            void notifyIterators(Listable* object) const;
 
             inline Identifier* getIdentifier() const { return this->identifier_; }
Index: /code/branches/core6/src/libraries/core/object/ObjectListIterator.h
===================================================================
--- /code/branches/core6/src/libraries/core/object/ObjectListIterator.h	(revision 9572)
+++ /code/branches/core6/src/libraries/core/object/ObjectListIterator.h	(revision 9573)
@@ -223,5 +223,5 @@
                 @param object The object to compare with
             */
-            inline void incrementIfEqual(OrxonoxClass* object)
+            inline void incrementIfEqual(Listable* object)
             {
                 if (this->element_ && this->element_->objectBase_ == object)