Index: code/branches/core6/src/libraries/core/CorePrereqs.h
===================================================================
--- code/branches/core6/src/libraries/core/CorePrereqs.h	(revision 9574)
+++ code/branches/core6/src/libraries/core/CorePrereqs.h	(revision 9577)
@@ -140,4 +140,5 @@
     class ConfigFileManager;
     class ConfigFileSection;
+    class Configurable;
     class ConfigValueContainer;
     class Context;
Index: code/branches/core6/src/libraries/core/class/CMakeLists.txt
===================================================================
--- code/branches/core6/src/libraries/core/class/CMakeLists.txt	(revision 9574)
+++ code/branches/core6/src/libraries/core/class/CMakeLists.txt	(revision 9577)
@@ -3,4 +3,3 @@
   Identifier.cc
   IdentifierManager.cc
-  OrxonoxClass.cc
 )
Index: code/branches/core6/src/libraries/core/class/OrxonoxClass.cc
===================================================================
--- code/branches/core6/src/libraries/core/class/OrxonoxClass.cc	(revision 9574)
+++ 	(revision )
@@ -1,53 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Fabian 'x3n' Landau
- *   Co-authors:
- *      ...
- *
- */
-
-/**
-    @file
-    @brief Implementation of OrxonoxClass.
-*/
-
-#include "OrxonoxClass.h"
-
-#include <cassert>
-
-namespace orxonox
-{
-    /**
-        @brief Constructor: Sets the default values.
-    */
-    OrxonoxClass::OrxonoxClass()
-    {
-    }
-
-    /**
-        @brief Destructor: Notifies all DestructionListener (for example @ref WeakPtr "weak pointers") that this object is being deleted.
-    */
-    OrxonoxClass::~OrxonoxClass()
-    {
-    }
-}
Index: code/branches/core6/src/libraries/core/class/OrxonoxClass.h
===================================================================
--- code/branches/core6/src/libraries/core/class/OrxonoxClass.h	(revision 9574)
+++ code/branches/core6/src/libraries/core/class/OrxonoxClass.h	(revision 9577)
@@ -43,5 +43,5 @@
 #include "core/CorePrereqs.h"
 
-#include "core/object/Listable.h"
+#include "core/config/Configurable.h"
 #include "core/object/Destroyable.h"
 
@@ -49,16 +49,10 @@
 {
     /**
-        @brief The class all objects and interfaces of the game-logic (not the engine) are derived from.
+        @brief This is the class from which all objects and interfaces of the game-logic (not the engine) are derived from.
 
         The BaseObject and Interfaces are derived with @c virtual @c public @c OrxonoxClass from OrxonoxClass.
     */
-    class _CoreExport OrxonoxClass : virtual public Listable, virtual public Destroyable
+    class _CoreExport OrxonoxClass : virtual public Configurable, virtual public Destroyable
     {
-        public:
-            OrxonoxClass();
-            virtual ~OrxonoxClass();
-
-            /// Function to collect the SetConfigValue-macro calls.
-            void setConfigValues() {};
     };
 }
Index: code/branches/core6/src/libraries/core/config/Configurable.h
===================================================================
--- code/branches/core6/src/libraries/core/config/Configurable.h	(revision 9577)
+++ code/branches/core6/src/libraries/core/config/Configurable.h	(revision 9577)
@@ -0,0 +1,55 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file
+    @ingroup Config ConfigFile
+    @brief Declaration of Configurable, the base class of all objects which may contain config values.
+*/
+
+#ifndef _Configurable_H__
+#define _Configurable_H__
+
+#include "core/CorePrereqs.h"
+
+#include "core/object/Listable.h"
+
+namespace orxonox
+{
+    /**
+        @brief This is the base class of all objects which may contain config values
+    */
+    class _CoreExport Configurable : virtual public Listable
+    {
+        public:
+            /// Function to collect the SetConfigValue-macro calls.
+            void setConfigValues() {};
+    };
+}
+
+#endif /* _Configurable_H__ */