Index: code/branches/core6/src/libraries/core/Core.h
===================================================================
--- code/branches/core6/src/libraries/core/Core.h	(revision 9577)
+++ code/branches/core6/src/libraries/core/Core.h	(revision 9578)
@@ -66,5 +66,5 @@
         You should only create this singleton once because it destroys the identifiers!
     */
-    class _CoreExport Core : public Singleton<Core>, public OrxonoxClass
+    class _CoreExport Core : public Singleton<Core>, public Configurable
     {
         friend class Singleton<Core>;
Index: code/branches/core6/src/libraries/core/Game.h
===================================================================
--- code/branches/core6/src/libraries/core/Game.h	(revision 9577)
+++ code/branches/core6/src/libraries/core/Game.h	(revision 9578)
@@ -50,5 +50,5 @@
 #include "util/DestructionHelper.h"
 #include "util/Singleton.h"
-#include "class/OrxonoxClass.h"
+#include "config/Configurable.h"
 
 /**
@@ -82,5 +82,5 @@
     class _CoreExport Game
 // tolua_end
-        : public Singleton<Game>, public OrxonoxClass
+        : public Singleton<Game>, public Configurable
     { // tolua_export
         friend class Singleton<Game>;
Index: code/branches/core6/src/libraries/core/GraphicsManager.h
===================================================================
--- code/branches/core6/src/libraries/core/GraphicsManager.h	(revision 9577)
+++ code/branches/core6/src/libraries/core/GraphicsManager.h	(revision 9578)
@@ -52,5 +52,5 @@
 #include "util/DestructionHelper.h"
 #include "util/Singleton.h"
-#include "class/OrxonoxClass.h"
+#include "config/Configurable.h"
 
 // tolua_begin
@@ -63,5 +63,5 @@
     class _CoreExport GraphicsManager
 // tolua_end
-        : public Singleton<GraphicsManager>, public OrxonoxClass, public Ogre::LogListener
+        : public Singleton<GraphicsManager>, public Configurable, public Ogre::LogListener
     { // tolua_export
         friend class Singleton<GraphicsManager>;
Index: code/branches/core6/src/libraries/core/command/Shell.cc
===================================================================
--- code/branches/core6/src/libraries/core/command/Shell.cc	(revision 9577)
+++ code/branches/core6/src/libraries/core/command/Shell.cc	(revision 9578)
@@ -96,5 +96,5 @@
     Shell::~Shell()
     {
-        this->inputBuffer_->destroy();
+        delete this->inputBuffer_;
 
         OutputManager::getInstance().unregisterListener(this);
Index: code/branches/core6/src/libraries/core/input/InputBuffer.h
===================================================================
--- code/branches/core6/src/libraries/core/input/InputBuffer.h	(revision 9577)
+++ code/branches/core6/src/libraries/core/input/InputBuffer.h	(revision 9578)
@@ -34,5 +34,5 @@
 #include <list>
 #include <string>
-#include "core/class/OrxonoxClass.h"
+#include "core/config/Configurable.h"
 #include "InputHandler.h"
 
@@ -74,5 +74,5 @@
     };
 
-    class _CoreExport InputBuffer : public InputHandler, public OrxonoxClass
+    class _CoreExport InputBuffer : public InputHandler, public Configurable
     {
         public:
Index: code/branches/core6/src/libraries/core/input/InputManager.cc
===================================================================
--- code/branches/core6/src/libraries/core/input/InputManager.cc	(revision 9577)
+++ code/branches/core6/src/libraries/core/input/InputManager.cc	(revision 9578)
@@ -280,5 +280,5 @@
         this->destroyState("calibrator");
         // Destroy KeyDetector and state
-        calibratorCallbackHandler_->destroy();
+        delete calibratorCallbackHandler_;
         // Destroy the empty InputState
         this->destroyStateInternal(this->emptyState_);
Index: code/branches/core6/src/libraries/core/input/KeyBinderManager.h
===================================================================
--- code/branches/core6/src/libraries/core/input/KeyBinderManager.h	(revision 9577)
+++ code/branches/core6/src/libraries/core/input/KeyBinderManager.h	(revision 9578)
@@ -36,5 +36,5 @@
 
 #include "util/Singleton.h"
-#include "core/class/OrxonoxClass.h"
+#include "core/config/Configurable.h"
 
 namespace orxonox //tolua_export
@@ -53,5 +53,5 @@
     */
     class _CoreExport KeyBinderManager //tolua_export
-        : public Singleton<KeyBinderManager>, public OrxonoxClass
+        : public Singleton<KeyBinderManager>, public Configurable
     { //tolua_export
         friend class Singleton<KeyBinderManager>;
Index: code/branches/core6/src/libraries/network/WANDiscovery.h
===================================================================
--- code/branches/core6/src/libraries/network/WANDiscovery.h	(revision 9577)
+++ code/branches/core6/src/libraries/network/WANDiscovery.h	(revision 9578)
@@ -32,5 +32,5 @@
 #include "packet/ServerInformation.h"
 #include "core/CoreIncludes.h"
-#include "core/class/OrxonoxClass.h"
+#include "core/config/Configurable.h"
 #include "core/config/ConfigValueIncludes.h"
 #include "MasterServerComm.h"
@@ -47,5 +47,5 @@
   class _NetworkExport WANDiscovery
 // tolua_end
-    : public OrxonoxClass
+    : public Configurable
   { // tolua_export
     public: