Index: code/branches/core6/src/modules/designtools/ScreenshotManager.cc
===================================================================
--- code/branches/core6/src/modules/designtools/ScreenshotManager.cc	(revision 9578)
+++ code/branches/core6/src/modules/designtools/ScreenshotManager.cc	(revision 9579)
@@ -42,4 +42,5 @@
 #include <OgreViewport.h>
 
+#include "core/CoreIncludes.h"
 #include "core/config/ConfigValueIncludes.h"
 #include "core/GraphicsManager.h"
Index: code/branches/core6/src/modules/docking/Dock.h
===================================================================
--- code/branches/core6/src/modules/docking/Dock.h	(revision 9578)
+++ code/branches/core6/src/modules/docking/Dock.h	(revision 9579)
@@ -40,5 +40,4 @@
 #include <set>
 
-#include "core/CoreIncludes.h"
 #include "core/EventIncludes.h"
 #include "core/XMLPort.h"
Index: code/branches/core6/src/modules/docking/DockingAnimation.cc
===================================================================
--- code/branches/core6/src/modules/docking/DockingAnimation.cc	(revision 9578)
+++ code/branches/core6/src/modules/docking/DockingAnimation.cc	(revision 9579)
@@ -35,4 +35,5 @@
 
 #include "DockingEffect.h"  // For DockingEffect::findTarget
+#include "core/CoreIncludes.h"
 
 namespace orxonox
Index: code/branches/core6/src/modules/docking/DockingAnimation.h
===================================================================
--- code/branches/core6/src/modules/docking/DockingAnimation.h	(revision 9578)
+++ code/branches/core6/src/modules/docking/DockingAnimation.h	(revision 9579)
@@ -36,5 +36,4 @@
 #define _DockingAnimation_H__
 
-#include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
 
Index: code/branches/core6/src/modules/docking/DockingController.cc
===================================================================
--- code/branches/core6/src/modules/docking/DockingController.cc	(revision 9578)
+++ code/branches/core6/src/modules/docking/DockingController.cc	(revision 9579)
@@ -34,4 +34,5 @@
 #include "worldentities/ControllableEntity.h"
 #include "Dock.h"
+#include "core/CoreIncludes.h"
 
 namespace orxonox
Index: code/branches/core6/src/modules/docking/DockingEffect.cc
===================================================================
--- code/branches/core6/src/modules/docking/DockingEffect.cc	(revision 9578)
+++ code/branches/core6/src/modules/docking/DockingEffect.cc	(revision 9579)
@@ -33,4 +33,5 @@
 
 #include "DockingEffect.h"
+#include "core/CoreIncludes.h"
 
 namespace orxonox
Index: code/branches/core6/src/modules/docking/DockingEffect.h
===================================================================
--- code/branches/core6/src/modules/docking/DockingEffect.h	(revision 9578)
+++ code/branches/core6/src/modules/docking/DockingEffect.h	(revision 9579)
@@ -36,5 +36,4 @@
 #define _DockingEffect_H__
 
-#include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
 
Index: code/branches/core6/src/modules/docking/DockingPrecompiledHeaders.h
===================================================================
--- code/branches/core6/src/modules/docking/DockingPrecompiledHeaders.h	(revision 9578)
+++ code/branches/core6/src/modules/docking/DockingPrecompiledHeaders.h	(revision 9579)
@@ -45,5 +45,4 @@
 
 #include "core/BaseObject.h"
-#include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
 
Index: code/branches/core6/src/modules/docking/DockingTarget.cc
===================================================================
--- code/branches/core6/src/modules/docking/DockingTarget.cc	(revision 9578)
+++ code/branches/core6/src/modules/docking/DockingTarget.cc	(revision 9579)
@@ -33,4 +33,5 @@
 
 #include "DockingTarget.h"
+#include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
 
Index: code/branches/core6/src/modules/docking/MoveToDockingTarget.cc
===================================================================
--- code/branches/core6/src/modules/docking/MoveToDockingTarget.cc	(revision 9578)
+++ code/branches/core6/src/modules/docking/MoveToDockingTarget.cc	(revision 9579)
@@ -36,4 +36,5 @@
 
 #include "core/XMLPort.h"
+#include "core/CoreIncludes.h"
 
 namespace orxonox
Index: code/branches/core6/src/modules/objects/SpaceBoundaries.h
===================================================================
--- code/branches/core6/src/modules/objects/SpaceBoundaries.h	(revision 9578)
+++ code/branches/core6/src/modules/objects/SpaceBoundaries.h	(revision 9579)
@@ -36,5 +36,4 @@
 #include <vector>
 
-#include "core/CoreIncludes.h"
 #include "core/object/WeakPtr.h"
 
Index: code/branches/core6/src/modules/pong/PongAI.h
===================================================================
--- code/branches/core6/src/modules/pong/PongAI.h	(revision 9578)
+++ code/branches/core6/src/modules/pong/PongAI.h	(revision 9579)
@@ -44,4 +44,5 @@
 
 #include "controllers/Controller.h"
+#include "PongBall.h"
 
 namespace orxonox
Index: code/branches/core6/src/modules/towerdefense/TowerDefense.cc
===================================================================
--- code/branches/core6/src/modules/towerdefense/TowerDefense.cc	(revision 9578)
+++ code/branches/core6/src/modules/towerdefense/TowerDefense.cc	(revision 9579)
@@ -87,4 +87,5 @@
 
 #include "chat/ChatManager.h"
+#include "core/CoreIncludes.h"
 
 /* Part of a temporary hack to allow the player to add towers */